(*
include Printexc
*)


type t = exn = ..

(*
type t = exn
*)



type raw_backtrace = Printexc.raw_backtrace

(*
type raw_backtrace = ()
*)


type backtrace_slot = Printexc.backtrace_slot

(*
type backtrace_slot
*)


type location = Printexc.location =
  {
  filename: string ;
  line_number: int ;
  start_char: int ;
  end_char: int }

(*
type location =
  {
  filename: string ;
  line_number: int ;
  start_char: int ;
  end_char: int }
*)


module Slot = Printexc.Slot

(*
module Slot = struct
  type t = backtrace_slot

  let is_raise = Printexc.Slot.is_raise
  let location = Printexc.Slot.location
  let format = Printexc.Slot.format

(*
  let is_raise _ =
    failwith "Unimplemented."

  let location _ =
    failwith "Unimplemented."

  let format _ _ =
    failwith "Unimplemented."
*)

  let is_inline _ =
    failwith "Unimplemented."
end
*)


type raw_backtrace_slot = Printexc.raw_backtrace_slot

(*
type raw_backtrace_slot
*)


external raise_with_backtrace :
  exn -> raw_backtrace -> 'a = "%raise_with_backtrace"

(*
let raise_with_backtrace exn _ =
  raise exn
*)


let get_raw_backtrace_next_slot = Printexc.get_raw_backtrace_next_slot

(*
let get_raw_backtrace_next_slot _ =
  failwith "Unimplemented."
*)


let set_uncaught_exception_handler = Printexc.set_uncaught_exception_handler

let backtrace_slots = Printexc.backtrace_slots

let raw_backtrace_length = Printexc.raw_backtrace_length

let get_raw_backtrace_slot = Printexc.get_raw_backtrace_slot

let convert_raw_backtrace_slot = Printexc.convert_raw_backtrace_slot

let exn_slot_id = Printexc.exn_slot_id

let exn_slot_name = Printexc.exn_slot_name

(*
let set_uncaught_exception_handler _ =
  failwith "Unimplemented."

let backtrace_slots _ =
  failwith "Unimplemented."

let raw_backtrace_length _ =
  failwith "Unimplemented."

let get_raw_backtrace_slot _ =
  failwith "Unimplemented."

let convert_raw_backtrace_slot _ =
  failwith "Unimplemented."

let exn_slot_id _ =
  failwith "Unimplemented."

let exn_slot_name _ =
  failwith "Unimplemented."
*)


let get_raw_backtrace = Printexc.get_raw_backtrace

let print_raw_backtrace = Printexc.print_raw_backtrace

let raw_backtrace_to_string = Printexc.raw_backtrace_to_string

let get_callstack = Printexc.get_callstack

(*
let get_raw_backtrace _ = ()

let print_raw_backtrace _ =
  failwith "Unimplemented."

let raw_backtrace_to_string _ =
  failwith "Unimplemented."

let get_callstack _ =
  failwith "Unimplemented."
*)


let print_backtrace = Printexc.print_backtrace

let get_backtrace = Printexc.get_backtrace

let record_backtrace = Printexc.record_backtrace

let backtrace_status = Printexc.backtrace_status

let register_printer = Printexc.register_printer

(*
let print_backtrace _ =
  failwith "Unimplemented."

let get_backtrace _ =
  failwith "Unimplemented."

let record_backtrace _ =
  failwith "Unimplemented."

let backtrace_status _ =
  failwith "Unimplemented."

let register_printer _ =
  failwith "Unimplemented."
*)

let to_string = Printexc.to_string
let print = Printexc.print
let catch = Printexc.catch
